def F_fibonacci(n,n_csv):
    open(n_csv,'w').write('tttt')	
    c_00 = ''
    a, b = 0, 1
    for it in range(n):
        a, b = b, a + b
        c_00 += str(a) +'\n'
    open(n_csv,'w').write(c_00)

def F_dsum(x, y, n_csv):
    open(n_csv,'w').write(str(2 * (x + y))+'\n \n ')

def F_dbase_list(n_db,n_sql,n_csv):
    import sqlite3
    cursor = sqlite3.connect(n_db, detect_types=sqlite3.PARSE_DECLTYPES | sqlite3.PARSE_COLNAMES).cursor()
    
    cursor.execute(
        """
        SELECT
        t.Name AS Track, alb.Title AS Album,  art.Name AS Artist, t.Composer
        FROM PlaylistTrack pt
        INNER JOIN Track t ON pt.TrackId = t.TrackId
        INNER JOIN Album alb ON t.AlbumId = alb.AlbumId
        INNER JOIN Artist art ON alb.ArtistId = art.ArtistId
        WHERE PlaylistId = ?
        """, (n_sql,))

    open(n_csv,'w').write(','.join(it[0] for it in cursor.description)+'\n')
    open(n_csv,'a').write('\n'.join(','.join(str(it1).replace(',',' ') for it1 in it) for it in cursor))
        

def F_dbase_combo(n_db,n_sql,n_csv):
    import sqlite3
    cursor = sqlite3.connect(n_db, detect_types=sqlite3.PARSE_DECLTYPES | sqlite3.PARSE_COLNAMES).cursor()
    open(n_csv,'w').write('\n'.join(it[1] for it in cursor.execute(n_sql)))


def F_simulation(n_0,n_1,n_2,n_3,n_4,n_5,n_csv):
    import numpy as np
    n_3=np.log(1 + float(n_3))
    n_4=float(n_4)
    n_6=float(float(n_1)/n_2)

    perc_selection = [5, 50, 95]  # hardcoded

    price = np.zeros((n_2 + 1, n_0))  
    percentiles = np.zeros((n_2 + 1, 3))
    
    price[0,:] = n_5
    percentiles[0,:] = n_5
    
    for t in range(1, n_2 + 1):
        rand_nums = np.random.randn(n_0)
        price[t,:] = price[t-1,:] * np.exp((n_3 - 0.5 * n_4**2) * n_6 + n_4 * rand_nums * np.sqrt(n_6))
        percentiles[t, :] = np.percentile(price[t, :], perc_selection)

    sy=[t* n_6 for t in range(0,n_2+1)]

    open(n_csv,'w').write('\n'.join(str(it[0])+"," +str(it[1])+"," + str(it[2]) +','+str(it1[0]) +','+str(it2) for (it,it1,it2) in zip(percentiles,price,sy)))


def F_web(n_url,n_csv):
    import requests
    
    open(n_csv, 'w').write(requests.get(n_url).text.replace('\t',',').replace(' ',''))


def F_plot(n,n_png):
    import numpy as np
    import matplotlib.pyplot as plt
    
    # Based on: http://matplotlib.org/users/screenshots.html#streamplot
    Y, X = np.mgrid[-3:3:100j, -3:3:100j]
    U = -1 + n * X**2 + Y
    V = 1 - n * X - Y**2

    fig, ax = plt.subplots(figsize=(6, 4))
    strm = ax.streamplot(X, Y, U, V, color=U, linewidth=2, cmap=plt.cm.autumn)
    fig.colorbar(strm.lines)

    fig.savefig(n_png)


